/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.controller;

import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.utils.RamVizualizer;
import j8086emu.view.GUI;

/**
 *
 * @author sone
 */
public class RamController {

    private final RamVizualizer ramVizualizer;
    private final int START_ADRESS = 0;
    private final int END_ADRESS = 0xFFFF;
    private StringBuffer ramMap;
    private final CPU cpu;
    private final GUI gui;

    public RamController(GUI gui) {
        this.cpu = gui.getCpu();
        this.ramVizualizer = new RamVizualizer(this.cpu);
        this.gui = gui;
    }

    public void createRamMap() {
        if (ramMap == null) {
            ramMap = new StringBuffer();
        }
        ramMap.append(ramVizualizer.getRamMap(START_ADRESS, END_ADRESS));
        gui.getRamArea().setText(ramMap.toString());
        ramVizualizer.setRamMap(ramMap);
    }

    public void updateRamMap(int startAdress, int endAdress) throws RamOutOfRangeExeption {
        ramVizualizer.updateRam(startAdress, endAdress);
        int i = gui.getjScrollPane4().getVerticalScrollBar().getValue();
        gui.getRamArea().setText(ramVizualizer.getRamMap().toString());
        gui.getjScrollPane4().getVerticalScrollBar().setValue(i);
        gui.getRamArea().updateUI();
    }

    public void setRamCell(char cellNum, int data) throws RamOutOfRangeExeption {
        cpu.setRamData(cellNum, data);
    }

    public void visualizeStack() {
        gui.getStackArea().setText(ramVizualizer.getStack());
    }

    public CPU getCpu() {
        return cpu;
    }
}
