/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.ram;

import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.interfaces.Widgetable;
import j8086emu.view.TextWidget;

/**
 * @author sone
 */
public class Ram implements Widgetable {

    private RamSegment ramData;
    private TextWidget widget;

    public Ram() {
        this.ramData = new RamSegment();
    }

    public void setByte(int cellNum, int data) throws RamOutOfRangeExeption {
        ramData.setByte(cellNum, data);
    }

    public int getByte(int cellNum) {
        return ramData.getByte(cellNum);
    }

    public int getByteUnsafe(int cellNum) {
        if (ramData.getByte(cellNum) == null) {
            return 0;
        } else {
            return ramData.getByte(cellNum);
        }
    }

    public void reset(){
        ramData = new RamSegment();
    }

    public void setWidget(TextWidget wid) {
        widget = wid;
        updateWidget();
    }

    public void removeWidget() {
        widget = null;
    }

    public void updateWidget() {
    }

    private class RamSegment {

        private Integer[] segment;

        public RamSegment() {
            this.segment = new Integer[1048576];
        }

        public Integer getByte(int cellNum) {
            if (segment[cellNum] == null) {
                try {
                    segment[cellNum] = 0;
                } catch (Exception ignored) {
                }
            }
            return segment[cellNum];
        }

        public void setByte(int cellNum, int data) throws RamOutOfRangeExeption {

            try {
                if (segment[cellNum] == null) {
                    segment[cellNum] = 0;
                }
                this.segment[cellNum] = data;
            } catch (Exception e) {
                throw new RamOutOfRangeExeption();
            }
        }
    }
}
