/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.registers;

import j8086emu.model.hardware.formats.GeneralRegisterDataFormat;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.interfaces.Widgetable;
import j8086emu.model.progcode.types.VarTypes;
import j8086emu.view.TextWidget;

/**
 *
 * @author sone
 */
public class GeneralRegister implements Variable, Widgetable {

    private final String name;
    private final GeneralRegisterDataFormat data;
    private TextWidget widget;
    private final int MAX = 65535;
    private final int MIN = 0;
    private final VarTypes type = VarTypes.reg16;

    public GeneralRegister(String name) {
        this.data = new GeneralRegisterDataFormat(type, 0);
        this.name = name;
    }

    /*public String getName() {
        return name;
    }*/

    public int getData() {
        return data.getData();
    }

    public int getLowBits() {
        return data.getLowBits();
    }

    public int getHighBits() {
        return data.getHighBits();
    }

    public void setData(int data) {
        this.data.setData(data);
        updateWidget();
    }

    public VarTypes getType() {
        return type;
    }

    public void setHighBits(int data) {
        this.data.setHighBitsData(data);
        updateWidget();
    }

    public void setLowBits(int data) {
        this.data.setLowBitsData(data);
        updateWidget();
    }

    public void setHexData(String hexData) {
        this.data.setHexData(hexData);
        updateWidget();
    }

    public void setWidget(TextWidget wid) {
        widget = wid;
        updateWidget();
    }

    public void removeWidget() {
        widget = null;
    }

    public void updateWidget() {
        if (null != widget) {
            widget.update(name, data.getHexData());
        }
    }

    public boolean isOverflow() {
        System.out.println(getData());
        return (getData() > MAX) || (getData() < MIN);
    }
}
