/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.hardware.registers;

import j8086emu.model.interfaces.Variable;
import j8086emu.model.interfaces.Widgetable;
import j8086emu.model.progcode.types.VarTypes;
import j8086emu.model.utils.Data;
import j8086emu.view.TextWidget;

/**
 *
 * @author sone
 */
public class SimpleRegister implements Variable, Widgetable {

    private int data;
    private final String name;
    private TextWidget widget;
    private VarTypes type;

    public SimpleRegister(String name, int data, VarTypes type) {
        this.name = name;
        this.data = data;
        this.type = type;
    }

    public int getData() {
        return data;
    }

    public void setData(int arg) {
        data = arg;
        updateWidget();
    }

    public VarTypes getType() {
        return type;
    }

    public void setWidget(TextWidget wid) {
        widget = wid;
        updateWidget();
    }

    public void removeWidget() {
        widget = null;
    }

    public void updateWidget() {
        if (null != widget) {      
            widget.update(name, getHexData());
        }
    }

    String getHexData() {
        return Data.intToHex(data, 4);
    }

    /*public String getName() {
        return name;
    }*/
}
