package j8086emu.model.progcode;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;

import java.util.HashMap;

/**
 * @author vlad
 *         Date: 27.03.2010
 *         Time: 0:22:28
 */
public class AssumeCommand extends Command {

    private CPU cpu;
    private HashMap<String, Segment> segmentsMap;
    private String args;
    
    public AssumeCommand(String args, CPU cpu, HashMap<String, Segment> segmentsMap, int length) {
        super(null, null);
        this.cpu = cpu;
        this.segmentsMap = segmentsMap;
        this.args = args;
    }

    public void perform() throws InvalidArgumentExeption {
        args = args.toUpperCase();
        String[] argsParts = args.split(",");
        for(String part : argsParts) {
            part = part.trim().replaceAll(" ", "");
            if(part.matches("CS:.+")) {
                setSegAddrToRegister("CS", part.replaceFirst("CS:", ""));
            } else if(part.matches("DS:.+")) {
                setSegAddrToRegister("DS", part.replaceFirst("CS:", ""));
            } else if(part.matches("ES:.+")) {
                setSegAddrToRegister("ES", part.replaceFirst("CS:", ""));
            } else if(part.matches("SS:.+")) {
                setSegAddrToRegister("SS", part.replaceFirst("CS:", ""));
            } else {
                throw new InvalidArgumentExeption("Ошибочка");
            }
        }
    }

    private void setSegAddrToRegister(String regName, String segName) {
        int segAddr = segmentsMap.get(segName).getStartAddress();
        cpu.setRegData(regName, segAddr);
    }
}
