package j8086emu.model.progcode;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.progcode.instructions.ConditionalJump;

/**
 * @author vlad
 *         Date: 10.03.2010
 *         Time: 16:36:06
 */
public class Command {
    private Performable instruction;
    private String args;
    private int length = 3;    // Default length of instruction // TODO: different lengths of commands

    public Command(Performable instruction, String args) {
        this.instruction = instruction;
        this.args = args;        
    }

    public Command(int length) {
        this.length = length;
    }

    // TODO: remove exception
    public boolean isJump() {
        return instruction.isJump();
    }

    public void perform() throws InvalidArgumentExeption {
        if (null == instruction)
            return;
        instruction.perform(args);
    }

    public int getLength() {
        return length;
    }
}
