package j8086emu.model.progcode;

import j8086emu.model.utils.Properties;

import java.io.*;
import java.util.ArrayList;

/**
 * @author vlad
 *         Date: 16.04.2010
 *         Time: 1:30:17
 */
public class DosBoxConfigWriter {
    
    public void write() {
        ArrayList<String> config = readWithoutAutoexec(new ArrayList<String>());

        try {
            BufferedWriter out = new BufferedWriter(new FileWriter(Properties.TASM_CONF_PATH));
            out.write("[autoexec]\n");
            out.write("MOUNT C " + Properties.EXTERNAL_PROGS_PATH + "\n");
            out.write("MOUNT D " + Properties.TASM_PATH + "\n");
            out.write("D:\\\n");
            out.write("TASM C:\\" + Properties.CODE_FILENAME + " -o C:\\progcode.obj -l C:\\" + Properties.TASM_OUTPUT_FILENAME + "\n");
            out.write("exit\n");

            for(String line : config) {
                out.write(line + "\n");
            }
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private ArrayList<String> readWithoutAutoexec(ArrayList<String> config) {
        try {
            BufferedReader in = new BufferedReader(new FileReader(Properties.DOSBOX_PATH + "dosbox.conf"));
            String line;
            boolean autoexecSection = false;

            while ((line = in.readLine()) != null) {
                line = line.trim();

                if (line.equals("[autoexec]")) {
                    autoexecSection = true;
                } else if (line.startsWith("[") && line.endsWith("]")) {
                    autoexecSection = false;
                }

                if (!autoexecSection) {
                    config.add(line);
                }
            }
            in.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return config;
    }

}
