/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.progcode;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.utils.DigitsParser;

/**
 *
 * @author sone
 */
public class NameMap {

    private final CPU cpu;
    private VariableMap variableMap;
    private final DigitsParser digitsParser;

    /*public HardwareMap getHardwareMap() {
        return cpu.getHardwareMap();
    }*/

    public DigitsParser getDigitsParser() {
        return digitsParser;
    }

    public NameMap(CPU cpu) {
        this.cpu = cpu;
        variableMap = new VariableMap(cpu);
        digitsParser = new DigitsParser();
    }

    public CPU getCpu() {
        return cpu;
    }

    public Variable getObgectFromName(String name) throws InvalidArgumentExeption {
        name = name.toUpperCase();
        if ((name.charAt(0) == '[') && (name.endsWith("]"))){
            name = name.substring(1, name.length() - 1);
        }
        
        Variable result = (Variable) cpu.get(name);

        if (result == null) {
            result = variableMap.get(name);
        }
        
        if (result == null) {
            result = (Variable) digitsParser.parse(name);
        }

        if (result == null) {
            throw new InvalidArgumentExeption("Неверный аргумент");
        }
        return result;
    }

    public VariableMap getVariableMap(){
        return variableMap;
    }    
}
