package j8086emu.model.progcode;

/**
 *
 * @author vlad
 */
public class RedactedCodeSaver {

    private final ProgramCode programCode;
    private final CodeOptimizer codeOptimizer;

    public RedactedCodeSaver(ProgramCode progCode, CodeOptimizer optimizer) {
        programCode = progCode;
        codeOptimizer = optimizer;
    }

    public void save(String text) {
        String[] textStrings = text.split("\n|\r");
        programCode.clearCode();
        for (String codeLine : textStrings) {
            programCode.addString(codeLine);
        }
        codeOptimizer.optimize(programCode);
    }
}
