package j8086emu.model.progcode;

import java.util.HashMap;

/**
 * @author vlad
 *         Date: 10.03.2010
 *         Time: 16:04:01
 */
public class Segment {
    private int startAddress;
    private HashMap<Integer, Command> commandsMap;

    public Segment(int startAddress, HashMap commandsMap) {
        this.startAddress = startAddress;
        this.commandsMap = commandsMap;
    }

    public Command getCommandAt(int offset) {
        int fullAddress = (startAddress << 4) + offset;
        return commandsMap.get(fullAddress);
    }

    public int getStartAddress() {
        return startAddress;
    }

    public void setStartAddress(int startAddress) {
        this.startAddress = startAddress;
    }
}
