package j8086emu.model.progcode;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.types.DWType;
import j8086emu.model.progcode.types.VarTypes;
import j8086emu.model.utils.StringSplitter;

/**
 * J8086emu
 * User: Sone
 * Date: 25.03.2010
 * Time: 16:57:30
 */
public class VarParser {

    private NameMap nameMap;
    private CPU cpu;

    public VarParser(NameMap nameMap) {
        this.nameMap = nameMap;
        this.cpu = nameMap.getCpu();
    }

    public Variable[] getVar(String msg, int count) throws InvalidArgumentExeption {
        String[] args = StringSplitter.split(msg);
        Variable[] var = new Variable[count];
        if ((args[0].charAt(0) == '[') && args[0].endsWith("]")) {
                var[0] = new DWType(cpu, new VarParams(VarTypes.dw, nameMap.getObgectFromName(args[0]).getData()), VarTypes.mem);
            } else {
                var[0] = nameMap.getObgectFromName(args[0]);
            }
        //var[0] = nameMap.getObgectFromName(args[0]);
        if (count == 2) {
            if ((args[1].charAt(0) == '[') && args[1].endsWith("]")) {
                var[1] = new DWType(cpu, new VarParams(VarTypes.dw, nameMap.getObgectFromName(args[1]).getData()), VarTypes.mem);
            } else {
                var[1] = nameMap.getObgectFromName(args[1]);
            }
        }
        return var;
    }

    public CPU getCpu() {
        return cpu;
    }
}
