/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package j8086emu.model.progcode;

import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.types.DBType;
import j8086emu.model.progcode.types.DWType;
import j8086emu.model.progcode.types.Label;
import j8086emu.model.progcode.types.VarTypes;

import java.util.HashMap;

/**
 * @author sone
 */
class VariableMap {

    private HashMap map = new HashMap<String, Variable>();
    private CPU cpu;

    VariableMap(CPU cpu) {
        this.map = new HashMap<String, Variable>();
        this.cpu = cpu;
    }

    public Variable addVar(String name, VarTypes type, int adress) {
        Variable var = null;
        if (type == VarTypes.db){
            var = new DBType(cpu, new VarParams(type, adress), type);
        }
        if (type == VarTypes.dw){
            var = new DWType(cpu, new VarParams(type, adress), type);
        }
        if (type == VarTypes.rel) {
            var = new Label(type);
        }
        if (null != name) {
            map.put(name, var);
        }
        return var;
    }

    public Variable get(String name) {
        return (Variable) map.get(name);
    }
}
