package j8086emu.model.progcode.files;

import j8086emu.model.progcode.CodeOptimizer;
import j8086emu.model.progcode.PointerCode;
import j8086emu.model.progcode.ProgramCode;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author vlad
 */
public class Loader {

    private ProgramCode programCode;
    private CodeOptimizer codeOptimizer;
    private PointerCode pointerCode;

    public Loader(ProgramCode progCode, CodeOptimizer optimizer, PointerCode pointer) {
        codeOptimizer = optimizer;
        programCode = progCode;
        pointerCode = pointer;
    }

    public String[] load(String selectedFile) throws IOException {
        String codeLine;
        programCode.clearCode();
        BufferedReader bufferedreader = new BufferedReader(new FileReader(selectedFile));
        while (bufferedreader.ready()) {
            codeLine = bufferedreader.readLine();
            programCode.addString(codeLine + "\n");
        }
        String[] origCode = programCode.getCode();
        codeOptimizer.optimize(programCode);
        bufferedreader.close();
        pointerCode.reset();
        return origCode;
    }
    // Исходный код сразу во вьюху
}
