package j8086emu.model.progcode.files;

import j8086emu.model.progcode.CodeOptimizer;
import j8086emu.model.progcode.PointerCode;
import j8086emu.model.progcode.ProgramCode;
import j8086emu.model.progcode.RedactedCodeSaver;

import java.io.IOException;

/**
 * @author vlad
 *         Date: 12.03.2010
 *         Time: 15:40:04
 */
public class SaveLoadManager {
    private Saver saver;
    private Loader loader;
    private RedactedCodeSaver redactedCodeSaver;

    public SaveLoadManager(ProgramCode programCode, PointerCode pointerCode) {
        saver = new Saver();
        CodeOptimizer codeOptimizer = new CodeOptimizer();
        loader = new Loader(programCode, codeOptimizer, pointerCode);
        redactedCodeSaver = new RedactedCodeSaver(programCode, codeOptimizer);
    }

    public void saveInside(String text) {
        redactedCodeSaver.save(text);
    }

    public void saveOutside(String selectedFile, String text) {
        saver.save(selectedFile, text);
    }

    public String[] load(String selectedFile) throws IOException {
        return loader.load(selectedFile);
    }
}
