package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;
import j8086emu.model.progcode.types.VarTypes;

/**
 * @author vlad
 *         Date: 09.04.2010
 *         Time: 13:27:03
 */
public class ConditionalJump extends Performable {

    protected CPU cpu;
    
    private final int NUM_OF_ARGS = 1;
    private final VarParser varParser;
    private Variable label;
    private boolean wasJump = false;

    public ConditionalJump(VarParser varParser) {
        this.varParser = varParser;
        cpu = varParser.getCpu();
    }

    public boolean isJump() {
        return wasJump;
    }

    @Override
    public void perform(String arg) throws InvalidArgumentExeption {
        label = varParser.getVar(arg, NUM_OF_ARGS)[0];
        if (isValidTypes(label)) {
            if (isAllowCondition()) {
                cpu.setRegData("IP", label.getData());
                wasJump = true;
            } else {
                wasJump = false;    
            }
        } else {
            System.out.println(label.getType().toString());
            throw new InvalidArgumentExeption(label.getType().toString());//TODO текст ошибки

        }
    }

    protected boolean isAllowCondition() {
        return false;
    }

    private boolean isValidTypes(Variable var) {
        if (var.getType() == VarTypes.rel) {
            int jumpLength = var.getData() - cpu.getRegData("IP");
            if (-128 <= jumpLength || jumpLength <= 127)
                return true;
        }
        return false;
    }
}
