package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;
import j8086emu.model.progcode.types.VarTypes;
import j8086emu.model.utils.Data;

/**
 * @author vlad
 */
public class Dec extends Performable {

    private final int NUM_OF_ARGS = 1;
    private final VarParser varParser;
    private Variable[] var;

    public Dec(VarParser varParser) {
        this.varParser = varParser;
    }

    public void perform(String msg) throws InvalidArgumentExeption {

        //String[] arg = StringSplitter.split(msg);
        var = varParser.getVar(msg, NUM_OF_ARGS);//nameMap.getObgectFromName(arg[0]);
        if (isValidTypes(var)) {
            int num = var[0].getData();
            var[0].setData(Data.hexToInt(Integer.toHexString(var[0].getData() - 1), 4));
            CPU cpu = varParser.getCpu();
            if (var[0].getData() > num) {
                cpu.setFlagState("OF", true);
            } else {
                cpu.setFlagState("OF", false);
            }
            if (var[0].getData() >= 0) cpu.setFlagState("SF", true);
            else cpu.setFlagState("SF", false);

            if (var[0].getData() == 0) cpu.setFlagState("ZF", true);
            else cpu.setFlagState("ZF", false);

            cpu.setFlagState("PF", Data.evenLowSetBits(Data.intToHex(var[0].getData(), 4)));
            String first, second;
            first = Data.intToHex(var[0].getData(), 4);
            second = "FFFF";
            cpu.setFlagState("AF", Data.secondQuarterOverflow(first, second));
        } else {
            System.out.println(var[0].getType().toString() + " " + var[1].getType().toString());
            throw new InvalidArgumentExeption("Несоответствие типов");
        }
    }

    private boolean isValidTypes(Variable[] var) {
        if (isType0(VarTypes.reg8) || isType0(VarTypes.reg16) || isType0(VarTypes.mem))
            return true;
        return false;
    }

    private boolean isType0(VarTypes type) {
        return var[0].getType() == type;
    }

}
