package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.RunProgramHandler;
import j8086emu.model.progcode.VarParser;
import j8086emu.view.GUI;
import j8086emu.view.Screen;

/**
 * @author vlad
 */
public class Int extends Performable {

    private RunProgramHandler handler;
    private Variable[] var;
    private VarParser varParser;
    private CPU cpu;


    public Int(VarParser vp) {
        varParser = vp;
        cpu = varParser.getCpu();
    }

    public void perform(String args) throws InvalidArgumentExeption {
        var = varParser.getVar(args, 1);
        switch (var[0].getData()) {
            case 0x21:
                if (cpu.getRegData("AH") == 0x02) {
                    GUI gui = cpu.getGui();
                    Screen screen = gui.getScreen();
                    screen.setVisible(true);
                    if (cpu.getRegData("DL") != 8) {
                        //screen.getTextArea1().setText(screen.getTextArea1().getText() + Character.toString((char) cpu.getRegData("DL")));
                        screen.getTextArea1().append(Character.toString((char) cpu.getRegData("DL")));
                    } else {
                        screen.getTextArea1().setCaretPosition(screen.getTextArea1().getCaretPosition() - 1);
                    }
                }

                break;
            default:
                throw new InvalidArgumentExeption("Прерывание " + var[0].getData() + " не поддерживается в текущей версии программы");

        }
    }

    public void setRunProgramHandler(RunProgramHandler handler) {
        this.handler = handler;
    }


}
