package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;

/**
 * @author vlad
 */
public class Mul extends Performable {

    private final int NUM_OF_ARGS = 1;
    private final VarParser varParser;
    private final CPU cpu;

    public Mul(VarParser varParser) {
        this.varParser = varParser;
        this.cpu = varParser.getCpu();
    }

    public void perform(String msg) throws InvalidArgumentExeption {
        
//        GeneralRegister ax = (GeneralRegister) nameMap.getObgectFromName("AX");
//        GeneralRegister dx;
//        String[] arg = StringSplitter.split(msg);
        Variable[] var = varParser.getVar(msg, NUM_OF_ARGS);
        int result;
        int argValue = var[0].getData();
        if (argValue < 256) {
            cpu.setRegData("AX", cpu.getRegData("AL") * argValue);
            //ax.setData(ax.getLowBits() * argValue);
        } else {
//            dx = (GeneralRegister) nameMap.getObgectFromName("DX");
//            result = ax.getData() * argValue;
            result = cpu.getRegData("AX") * argValue;
            cpu.setRegData("DX", result / 65536);
            cpu.setRegData("AX", result % 65536);
//            ax.setData(result % 65536);
        }
    }
}
