/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.progcode.instructions;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Performable;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParser;

/**
 * @author sone
 */
public class Push extends Performable {

    private CPU cpu;
    private final int NUM_OF_ARGS = 1;
    private final VarParser varParser;

    public Push(VarParser varParser) {
        this.varParser = varParser;
        cpu = varParser.getCpu();
    }

    public void perform(String msg) throws InvalidArgumentExeption {
        /*String[] args = StringSplitter.split(msg);
        Variable[] var = new Variable[NUM_OF_ARGS];
        var[0] = nameMap.getObgectFromName(args[0]);*/
        Variable[] var = varParser.getVar(msg, NUM_OF_ARGS);

        int cellNum = cpu.getRegData("CS") * 16 + cpu.getRegData("SP");
        try {
            cpu.setRamData(cellNum, var[0].getData());
        } catch (RamOutOfRangeExeption ramOutOfRangeExeption) {
            ramOutOfRangeExeption.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        cpu.setRegData("SP", cpu.getRegData("SP") - 2);
    }
}
