package j8086emu.model.progcode.types;

import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.hardware.CPU;
import j8086emu.model.interfaces.Variable;
import j8086emu.model.progcode.VarParams;
import j8086emu.model.utils.Data;

/**
 * J8086emu
 * User: Sone
 * Date: 23.03.2010
 * Time: 19:20:46
 */
public class DWType implements Variable {
    private CPU cpu;
    private VarParams params;
    private VarTypes type;

    public DWType(CPU cpu, VarParams params, VarTypes type) {
        this.cpu = cpu;
        this.params = params;
        this.type = type;
    }

    public int getData() {
        int data = cpu.getRamData(params.getAdress());
        data *= 256;
        data += cpu.getRamData(params.getAdress() + 1);
        return data;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setData(int arg) {
        String hexData = Data.intToHex(arg, 4);
        try {
            cpu.setRamData(params.getAdress(), Data.hexToInt(hexData.substring(0,2),2));
            cpu.setRamData(params.getAdress() + 1, Data.hexToInt(hexData.substring(2),2));
        } catch (RamOutOfRangeExeption ramOutOfRangeExeption) {
            ramOutOfRangeExeption.printStackTrace();
        }
    }

    public VarTypes getType() {
        return type;
    }
}
