/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.utils;

import j8086emu.model.exeptions.InvalidArgumentExeption;
import j8086emu.model.hardware.formats.GeneralRegisterDataFormat;
import j8086emu.model.progcode.types.VarTypes;

/**
 * @author sone
 */
public class DigitsParser {

    private final int HEX = 16;
    private final int DEC = 10;
    private final int BIN = 2;

    public Object parse(String msg, String lengthParam) throws InvalidArgumentExeption {
        msg = msg.toLowerCase();
        boolean neg = false;
        if (msg.charAt(0) == '-') {
            neg = true;
            msg = msg.substring(1);
        }


        int maxDigit = 65535;
        try {
            if (VarTypes.valueOf(lengthParam) == VarTypes.db) {
                maxDigit = 256;
            }
        } catch (Exception e) {}

        final int digitLen = msg.length() - 1;
        final String msgPart = msg.substring(digitLen);
        final String noModedMsg = msg.substring(0, digitLen);

        if (msgPart.equals("h")) {
            try {
                int digit = Integer.parseInt(noModedMsg, HEX);
                return numProcessing(digit, lengthParam, neg, maxDigit);
            } catch (NumberFormatException e) {
                throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
            }
        } else {
            if (msgPart.equals("b")) {
                try {
                    int digit = Integer.parseInt(noModedMsg, BIN);
                    return numProcessing(digit, lengthParam, neg, maxDigit);
                    /* if (neg) digit = -digit;
                 if (digit > maxDigit) {
                     throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
                 }
                 return new GeneralRegisterDataFormat(VarTypes.valueOf(lengthParam), digit);*/
                } catch (NumberFormatException e) {
                    throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
                }
            } else {
                try {
                    int digit = Integer.parseInt(msg, DEC);
                    return numProcessing(digit, lengthParam, neg, maxDigit);
                    /* if (neg) digit = -digit;
                 if (digit > maxDigit) {
                     throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
                 }
                 return new GeneralRegisterDataFormat(VarTypes.valueOf(lengthParam), digit);*/
                } catch (NumberFormatException e) {
                    throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
                }
            }
        }
    }

    public Object parse(String msg) throws InvalidArgumentExeption {
        return parse(msg, "non");
    }

    private Object numProcessing(int digit, String lengthParam, boolean neg, int maxDigit) throws InvalidArgumentExeption {
        if (digit < 256) {
            lengthParam = "db";
            if (neg) digit = 256 - digit;
        } else {
            lengthParam = "dw";
            if (neg) digit = 65536 - digit;
            if (digit > maxDigit) {
                throw new InvalidArgumentExeption("Проверьте правильность ввода числовой константы");
            }
        }
        return new GeneralRegisterDataFormat(VarTypes.valueOf(lengthParam), digit);
    }
}
