/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package j8086emu.model.utils;

import j8086emu.model.exeptions.RamOutOfRangeExeption;
import j8086emu.model.hardware.CPU;

/**
 * @author sone
 */
public class RamVizualizer {

    private final int STRING_LEN = 16;
    private final int DEC_STRING_LEN = STRING_LEN - 1;
    private final int ADR_LEN = 7;
    private final int ADR_STRING_LEN = 59;
    private final int HEX = 16;
    private final int offset = 16;
    private final String space = " ";
    private final String zero = "0";
    private final String endOfLine = "\n";
    private StringBuffer ramMap;
    private final CPU cpu;

    public RamVizualizer(CPU cpu) {
        this.cpu = cpu;
    }

    public StringBuffer getRamMap(int startAdress, int endAdress) {
        StringBuffer result = new StringBuffer();
        startAdress -= startAdress % STRING_LEN;

        Integer num;
        StringBuffer adress = new StringBuffer("CS:0000 | ");
        String hexAdress;
        String data;
        for (int i = startAdress; i <= endAdress; i++) {
            if ((i % STRING_LEN) == 0) {
                hexAdress = Data.intToHex(i, 4);//Integer.toHexString(i);
                adress.replace(ADR_LEN - hexAdress.length(), ADR_LEN, hexAdress);
                result.append(adress);
            }
            num = cpu.getRamDataUnsafe(i);
            data = Data.intToHex(num, 2);//Integer.toHexString(num);
            if (data.length() == 1) {
                data = zero + data;
            }
            result = result.append(data).append(space);
            if ((i % STRING_LEN) == DEC_STRING_LEN) {
                result.append(endOfLine);
            }
        }
        return result;
    }

    public StringBuffer getRamMap() {
        return ramMap;
    }

    public void setRamMap(StringBuffer ramMap) {
        this.ramMap = ramMap;
    }

    public void updateRam(int startAdress, int endAdress) throws RamOutOfRangeExeption {
        StringBuffer updatedRam;
        int offset;
        startAdress += 32;
        do {
            startAdress -= 32;
            offset = ADR_STRING_LEN * (startAdress - startAdress % HEX) / HEX;

        } while ((offset > ramMap.length()));

        updatedRam = getRamMap(startAdress, endAdress);

        ramMap.replace(offset, updatedRam.length() + offset, updatedRam.toString());
    }

    public String getStack() {
        StringBuffer result = new StringBuffer();
        final String zeros = "0000 ";
        StringBuffer currentCell = new StringBuffer(zeros);
        System.out.println(cpu.getRegData("SP"));
        for (int i = cpu.getRegData("SP") + 2; i <= 0xffff; i += 2) {
            String num = Data.intToHex((cpu.getRamData(cpu.getRegData("CS") * offset + i)) + (cpu.getRamData(cpu.getRegData("CS") * offset + i - 1)) * 16, 4);//Integer.toHexString((cpu.getRamData(cpu.getRegData("CS") * offset + i)) + (cpu.getRamData(cpu.getRegData("CS") * offset + i - 1)) * 16);
            currentCell.replace(0, zeros.length(), zeros);
            currentCell.replace(4 - num.length(), 4, num);
            result.append(currentCell);
        }
        return result.toString();
    }
}
